package org.jastadd.relast.compiler;

import com.github.jknack.handlebars.Handlebars;
import com.github.jknack.handlebars.Template;
import com.github.jknack.handlebars.io.ClassPathTemplateLoader;
import com.github.jknack.handlebars.io.TemplateLoader;
import org.yaml.snakeyaml.Yaml;

import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;

public class Mustache {

  public static void javaMustache(String templateFileName, String yamlFileName, String outputFileName) throws IOException {

    Object context = new Yaml().load(new FileReader(yamlFileName));
    TemplateLoader loader = new ClassPathTemplateLoader();
    loader.setSuffix(".mustache"); // the default is ".hbs"

    Handlebars handlebars = new Handlebars(loader);
    handlebars.prettyPrint(true); // set handlebars to mustache mode (skip some whitespace)
    Template template = handlebars.compile(templateFileName);

    try (Writer w = new FileWriter(outputFileName)) {
      template.apply(context, w);
      w.flush();
    }
  }

}
